Ext.BLANK_IMAGE_URL = 'extjs/resources/images/default/s.gif';

Ext.onReady(function() {

	var olimpData = %OlimpData%;
	var langColors = new Array();
	%LangColors%
    
    var store = new Ext.data.SimpleStore({
        fields: [
           {name: 'position', type: 'int'},
           {name: 'user'},
           %ProblemsTypes%
           {name: 'points', type: 'int'}
        ]
    });
    store.loadData(olimpData);
    
	function colorize(text, lang, additionalAttr) {
        if (!langColors[lang]) return text;
        return '<span style="color:' + langColors[lang] + ';' + (additionalAttr != null ? additionalAttr : '') + '">' + text + '</span>';
    }

    function langRenderer(value, metadata, record, rowIndex, colIndex){
    	return colorize(value, record.data['problem' + (colIndex-1) + 'lang'], 'font-weight:bold;');
    }
    
    // create the Grid
    var grid = new Ext.grid.GridPanel({
        store: store,
        columns: [
            {header: "", width: 35, sortable: true, dataIndex: 'position'},
            {header: "", width: 200, sortable: true, dataIndex: 'user'},
            %TableHeaders%
            {header: "", width: 70, sortable: true, dataIndex: 'points', renderer: function(value) {return '<b>'+value+'</b>';}}
        ],
        stripeRows: true,
        enableHdMenu: false,
        enableColumnMove: false,
        bbar: %TableFooter%,
        height:500,
        width:%TableWidth%,
        title:' '
    });
    
	grid.on('rowdblclick', function (grid, rowIndex, e) {
		var record   = grid.getStore().getAt(rowIndex);
		var userId   = record.get('position');
		var wndTitle = record.get('user');
		
    	showUserWindow(userId, wndTitle, grid.getEl());
    });
	
	grid.render('content');
	
	SyntaxHighlighter.config['clipboardSwf'] = 'js/highlight/clipboard.swf';
	SyntaxHighlighter.config.strings['viewSource'] = '  ';
	SyntaxHighlighter.config.strings['copyToClipboard'] = '';
	SyntaxHighlighter.config.strings['copyToClipboardConfirmation'] = '     ';
	SyntaxHighlighter.config.strings['print'] = '';

	SyntaxHighlighter.defaults['auto-links'] = false;
    
});