var hWnd = new Array();

function showUserWindow(userId, wndTitle, parentGrid) {
	
	var justCreated = false;
	
	//if (!hWnd[userId]) {
		
		var checkResults = globalResults[wndTitle];
		                    
		var reader = new Ext.data.ArrayReader({}, [
		    {name: 'problem', type: 'string'},
		    {name: 'lang', type: 'string'},
		    {name: 'test', type: 'int'},
		    {name: 'result', type: 'string'},
		    {name: 'time', type: 'string'},
		    {name: 'points', type: 'int'},
		    {name: 'comment', type: 'string'}
		]);
		
		var summary = new Ext.grid.GroupSummary(); 
		
		var grid = new Ext.grid.GridPanel({
	        store: new Ext.data.GroupingStore({
	            reader: reader,
	            data: checkResults,
	            sortInfo: {field: 'test', direction: 'ASC'},
	            groupField: 'problem'
	        }),

	        columns: [
	            {id: 'test', header: '', width: 37, sortable: true, dataIndex: 'test'},
	            {header: '', width: 40, sortable: true, dataIndex: 'problem', hidden: true},
	            {header: '', width: 90, sortable: true, dataIndex: 'result', summaryType: 'count', summaryRenderer: function(v, params, data){
	            	var ost = v % 10;
	            	var suf = '';
	            	if ((v>10) && (v<20)) suf = '';
	            	else if ((ost>1) && (ost<5)) suf = '';
	            	else if ((ost>4) || (ost==0)) suf = '';
                    return '(' + v +' ' + suf + ')';
                }},
	            {header: '', width: 45, sortable: true, dataIndex: 'time'},
	            {header: '', width: 40, sortable: true, dataIndex: 'points', id: 'points', summaryType: 'sum'}
	        ],

	        view: new Ext.grid.GroupingView({
	            forceFit: true,
	            startCollapsed: true,
	            groupTextTpl: '{text} ({[values.rs[0].data["lang"]]})'
	        }),
	        
	        plugins: summary,
	        
	        border: false,
	        enableHdMenu: false,
	        enableColumnMove: false
	    });
		
		
		// Panel for the west
        var nav = new Ext.Panel({
            title: ' ',
            region: 'west',
            split: true,
            width: 275,
            collapsible: true,
            margins: '3 0 3 3',
            cmargins: '3 3 3 3',
            defaults  : {
				autoScroll : true
			},
			layout: 'fit',
            items: grid
        });
        
        hWnd[userId] = new Ext.Window({
            title: wndTitle + ' -  ',
            closable: true,
            //closeAction: 'hide',
            width: 700,
            height: 450,
            //border : false,
            plain: true,
            layout: 'border',
            items: nav
        });

        // tabs for the center
        var tabs = new Ext.TabPanel({
        	id: hWnd[userId].id+'-problemTabs',
            region    : 'center',
            margins   : '3 3 3 0', 
            activeTab : 0,
            enableTabScroll: true,
            defaults  : {
				autoScroll : true
			},
            items     : [{
                title : ' ',
                id    : hWnd[userId].id+'-sourceDataTab',
                html  : ''
             },{
                title : ' ',
                id    : hWnd[userId].id+'-inputDataTab',
                html  : ''
             },{ 
                title : '',
                id    : hWnd[userId].id+'-resultDataTab',
                html  : ''
             },{ 
                title : ' ',
                id    : hWnd[userId].id+'-answerDataTab',
                html  : ''
            }],
            bbar: [{ height: 56, xtype: 'tbtext', text: '<b>   :</b><br/>'}]
        });
        
        hWnd[userId].items.add(tabs);
        
        grid.on('rowdblclick', function (grid, rowIndex, e) {
			var record    = grid.getStore().getAt(rowIndex);
			var problemId = record.get('problem');
			var testId    = record.get('test');
			
	    	updateProblemTabs(hWnd[userId], wndTitle, problemId, testId, record.get('comment'));
	    });
        
        hWnd[userId].on('close', function (p) {
        	delete hWnd[userId];
        });
        
        justCreated = true;
	//}
	
	hWnd[userId].show(parentGrid);
	
	if (justCreated) {
		var wndTabs = hWnd[userId].findById(hWnd[userId].id+'-problemTabs');
		wndTabs.setActiveTab(hWnd[userId].id+'-inputDataTab');
		wndTabs.setActiveTab(hWnd[userId].id+'-resultDataTab');
		wndTabs.setActiveTab(hWnd[userId].id+'-answerDataTab');
		wndTabs.setActiveTab(hWnd[userId].id+'-sourceDataTab');
	}
}

function updateProblemTabs(hWnd, userId, problemId, testId, commentText) {
	var tabs = hWnd.findById(hWnd.id+'-problemTabs');
	
	tabs.getBottomToolbar().items.first().setText('<b>   :</b><br/>'+commentText);
	
	var srcTab = tabs.findById(hWnd.id+'-sourceDataTab');
	srcTab.load({
		url: './files/sources/'+userId+'/'+problemId+'.html',
		text: '...',
		callback: function() {
			SyntaxHighlighter.highlight();
		}
	});
	
	var inputTab = tabs.findById(hWnd.id+'-inputDataTab');
	inputTab.load({
		url: './files/tests/'+problemId+'/'+testId+'input.html',
		text: '...'
	});
	
	var resultTab = tabs.findById(hWnd.id+'-resultDataTab');
	resultTab.load({
		url: './files/sources/'+userId+'/'+problemId+'.'+testId+'result.html',
		text: '...'
	});
	
	var answerTab = tabs.findById(hWnd.id+'-answerDataTab');
	answerTab.load({
		url: './files/tests/'+problemId+'/'+testId+'answer.html',
		text: '...'
	});
}